#include <glib.h>
#include <gtk/gtk.h>
#include <pcap.h>

#define MAXIDLEN 10
#define MAXPASSLEN 10

gchar nespot_id[MAXIDLEN];
gchar nespot_pass[MAXPASSLEN];
gchar nespot_device[10];

GtkWidget *window; /* TOP LEVEL   */
GtkWidget *conn_dialog, *conn_label;

int fd; /* IO  */

gint update_login_state( gpointer data );
void pt_login_nespot( void *data );

/* callback functions */
/* delete_event callback */
static gboolean delete_event( GtkWidget *widget,
							  GdkEvent *event,
							  gpointer data )
{
	gtk_main_quit();

	return FALSE;
}

/* cb_getid, cb_getpass
 * connect ư "clicked" ñ׳ callback */
static void cb_getid( GtkWidget *widget, gpointer data )
{
	g_strlcpy( nespot_id, gtk_entry_get_text(GTK_ENTRY(data)), 10 );
}	

static void cb_getpass( GtkWidget *widget, gpointer data )
{
	g_strlcpy( nespot_pass, gtk_entry_get_text(GTK_ENTRY(data)), 10 );

	/*   Dialog  .  Լ nespot_connect ȣ */
	connect_dialog();
}

/* if_list combox_box "changed" ñ׳ callback */
static void cb_getdev( GtkWidget *widget, gpointer data )
{
	g_strlcpy( nespot_device, gtk_entry_get_text( GTK_ENTRY(GTK_BIN(data)->child) ), 10 );
}

/* About ư "clicked" ñ׳ callback */
static void cb_about( GtkWidget *widget, gpointer data )
{
	GtkWidget *dialog, *label;

	dialog = gtk_dialog_new_with_buttons("About GLinspot...",
										 GTK_WINDOW(window),
										 GTK_DIALOG_DESTROY_WITH_PARENT,
										 GTK_STOCK_OK,
										 GTK_RESPONSE_NO,
										 NULL );
	label = gtk_label_new("\n" \
						  "About This Program...\n" \
						  "\n\n" \
						  "\tGLinspot v0.1 alpha\n" \
						  "\n\n" \
						  "Nespot Console Programming\n\t<Jung, Kye-Ok>\n\n" \
						  "GLinspot GUI Programming\n\t<Park, Jin-Hyung>\n\n" \
						  "\n");
	
	g_signal_connect_swapped( GTK_OBJECT(dialog),
							  "response",
							  G_CALLBACK(gtk_widget_destroy),
							  GTK_OBJECT(dialog) );

	gtk_container_add( GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), label );

	gtk_widget_show_all( dialog );
}
/* end of callback functions */

/* Ʈũ ̽ ˻ؼ combo  Ѵ. */
static GtkWidget *make_if_list_combo()
{
	int i;
	char *errbuf;
	
	GtkWidget *combo;
	
	pcap_if_t *iflist; /* from libpcap */

	if( (i = pcap_findalldevs( &iflist, errbuf )) < 0 )
	{
		g_print( "*** ERROR *** : pcap_findalldevs\n" );
		gtk_main_quit();
	}
	
	combo = gtk_combo_box_entry_new_text();
	
	for( ; iflist->next != NULL ; iflist = iflist->next )
		gtk_combo_box_append_text(GTK_COMBO_BOX(combo), (gchar *)iflist->name );
	
	gtk_widget_set_size_request( combo, 70, -1 );

	g_signal_connect( G_OBJECT(combo), "changed",
					  G_CALLBACK(cb_getdev), (gpointer)combo );

	return combo;
}

/*   Dialog ڸ ǥ, ׽  */
void connect_dialog() {

	pthread_t tid;
	static int state;

	/* Create the widgets */
   
	conn_dialog = gtk_dialog_new_with_buttons ("Message",
                                         GTK_WINDOW(window),
                                         GTK_DIALOG_DESTROY_WITH_PARENT,
                                         GTK_STOCK_OK,
                                         GTK_RESPONSE_ACCEPT,
                                         NULL);
	
	conn_label = gtk_label_new ("\nConnecting...\n");
	gtk_widget_show(conn_label);
   
	/* Ensure that the dialog box is destroyed when the user responds. */
   
	g_signal_connect_swapped (GTK_OBJECT (conn_dialog), 
                             "response", 
                             G_CALLBACK (gtk_widget_destroy),
                             GTK_OBJECT (conn_dialog));
	/*
	g_signal_connect_after( GTK_OBJECT(dialog),
							"close",
							G_CALLBACK( cb_connect_result ),
							NULL );
							*/

	/* Add the label, and show everything we've added to the dialog. */

	gtk_container_add( GTK_CONTAINER (GTK_DIALOG(conn_dialog)->vbox),
                       conn_label );
	gtk_widget_show_all( conn_dialog );

	state = 2;
	gtk_timeout_add(50, &update_login_state, (void *)&state);
	pthread_create(&tid, NULL, pt_login_nespot, (void *)&state);
	pthread_detach(tid);
}

gint update_login_state( gpointer data )
{
	int state = *((int *)data);

	switch(state)
	{
		case 0:
			gtk_label_set_text(GTK_LABEL( conn_label ),
							   "Connection Failed...");
			gtk_widget_show_all( conn_dialog );
			return FALSE;
		case 1:
			gtk_label_set_text(GTK_LABEL( conn_label ),
							   "Connection Success...");
			gtk_widget_show_all( conn_dialog );
			return TRUE;
		case 2:
		default:
			return TRUE;
	}
}

void pt_login_nespot(void *data)
{
	int *state = (int *)data;

	*state = 2;
	if( nespot_connect( nespot_id, nespot_pass, nespot_device ) == -1 )
	{
		*state = 0;
		return NULL;
	} else {
		*state = 1;
		return NULL;
	}
}
		
		
/* α׷ Main Window */
static GtkWidget *make_main_window()
{
	GtkWidget *window;
	GtkWidget *table;
	
	GtkWidget *logo_box;
	GtkWidget *logo_label;

	GtkWidget *connect_table;
	GtkWidget *id_label;
	GtkWidget *pass_label;
	GtkWidget *id_input;
	GtkWidget *pass_input;

	GtkWidget *hbox;
	GtkWidget *if_combo;
	GtkWidget *save_cbutton;
	
	GtkWidget *connect_button;
	GtkWidget *about_button;

	/*     */
	window = gtk_window_new( GTK_WINDOW_TOPLEVEL );
	gtk_window_set_title( GTK_WINDOW(window), "GLinspot v0.1 Alpha ^_^;;" );
	g_signal_connect( G_OBJECT(window), "delete_event",
						G_CALLBACK(delete_event), NULL );
	gtk_container_set_border_width( GTK_CONTAINER(window), 10 );
	gtk_window_set_default_size( GTK_WINDOW(window), 300, 125 );
	
	/*   ġϱ  ü ̺   */
	table = gtk_table_new( 3, 1, FALSE );
	gtk_container_add( GTK_CONTAINER(window), table );
	gtk_table_set_row_spacing( GTK_TABLE(table), 0, 50 );

	/* ΰ    */
	logo_box = gtk_hbox_new( TRUE, 0 );
	gtk_table_attach_defaults( GTK_TABLE(table), logo_box, 0, 1, 0, 1 );
	
	logo_label = gtk_label_new( "Logo will be placed here! ^_^");
	gtk_box_pack_start( GTK_BOX(logo_box), logo_label, TRUE, FALSE, 0 );

	gtk_widget_show_all( logo_box );

	/* ̵, н, ̽ ޺, ȯ ư  ̺ */
	connect_table = gtk_table_new( 3, 2, FALSE );
	gtk_table_attach( GTK_TABLE(table), connect_table, 0, 1, 1, 2, \
					  GTK_FILL, GTK_FILL, 20, 0 );

	/* id Է  */
	id_label = gtk_label_new( "Username : " );
	gtk_table_attach_defaults( GTK_TABLE(connect_table), id_label, 0, 1, 0, 1 );
	gtk_misc_set_alignment( GTK_MISC(id_label), 1, 0.5 );
	id_input = gtk_entry_new_with_max_length( MAXIDLEN );
	gtk_table_attach( GTK_TABLE(connect_table), id_input, 1, 2, 0, 1, \
					  GTK_SHRINK, GTK_SHRINK, 0, 0);
	
	/* pass Է  */
	pass_label = gtk_label_new( "Password : " );
	gtk_table_attach_defaults( GTK_TABLE(connect_table), pass_label, 0, 1, 1, 2 );
	gtk_misc_set_alignment( GTK_MISC(pass_label), 1, 0.5 );
	pass_input = gtk_entry_new_with_max_length( MAXPASSLEN );
	gtk_entry_set_visibility( GTK_ENTRY(pass_input), FALSE );
	gtk_table_attach( GTK_TABLE(connect_table), pass_input, 1, 2, 1, 2 , \
					  GTK_SHRINK, GTK_SHRINK, 0, 0);

	/* Device  combo, config save check ư */
	hbox = gtk_hbox_new( FALSE, 0 );
	/* network interface  Combo  */
	if_combo = make_if_list_combo();
	/* ȯ  Check Box  */
	save_cbutton = gtk_check_button_new_with_label( "Save Configure" );

	gtk_box_pack_start( GTK_BOX(hbox), if_combo, TRUE, TRUE, 10 );
	gtk_box_pack_start( GTK_BOX(hbox), save_cbutton, TRUE, TRUE, 10 );
	gtk_table_attach( GTK_TABLE(connect_table), hbox, 0, 2, 2, 3, GTK_FILL, GTK_FILL, 10, 10 );
	gtk_widget_show_all( hbox );
	
	gtk_widget_show_all( connect_table );
	/* connect_table  */

	/* Connect ư, About ư  hbox */
	hbox = gtk_hbox_new( FALSE, 0 );
	/* Connect ư  */
	connect_button = gtk_button_new_with_label( "Connect" );
	g_signal_connect( G_OBJECT(connect_button), "clicked",
						G_CALLBACK(cb_getid), (gpointer)id_input );
	g_signal_connect_after( G_OBJECT(connect_button), "clicked",
						G_CALLBACK(cb_getpass), (gpointer)pass_input );
	gtk_widget_set_size_request( connect_button, 80, -1 );

	/* About ư  */
	about_button = gtk_button_new_with_label("About");
	gtk_widget_set_size_request( about_button, 80, -1 );
	g_signal_connect( G_OBJECT(about_button), "clicked",
					  G_CALLBACK(cb_about), NULL );
	
	gtk_box_pack_start( GTK_BOX(hbox), connect_button, TRUE, TRUE, 0 );
	gtk_box_pack_start( GTK_BOX(hbox), about_button, TRUE, TRUE, 0 );
	gtk_table_attach( GTK_TABLE(table), hbox, 0, 1, 2, 3, 1, 1, 0, 0 );
	gtk_widget_show_all( hbox );
	/* Connect ư, About ư hbox  */
	
	gtk_widget_show( table );
	/* ü table  */

	gtk_widget_show( window );
	/*    */

	return window;
}

int main(int argc, char *argv[])
{
	gtk_init( &argc, &argv );

	window = make_main_window();
	
	gtk_main();

	return 0;
}
